package com.dianafisher.chapter1;

import junit.framework.TestCase;

/**
 * Question 1.5 - Write a method to perform basic string compression using the counts of repeated characters.
 *                If the compressed string would not become smaller than the original string, then return the original string.
 *
 * Assumptions:
 *      *  Extended ASCII character set
 * */

public class StringCompression extends TestCase
{
    public String compress( String str )
    {
        // if there two or fewer character in the string, it cannot be reduced through compression.  So just return it.
        if( str.length() < 3 ) return str;
        StringBuilder builder = new StringBuilder();

        char first = str.charAt(0);
        int count = 1;
        // loop through string (linear)
        for( int i = 1; i < str.length(); i++ )
        {
//            System.out.println("first = " + first);
            char next = str.charAt(i);
            if( next == first )
            {
                count++;
            }
            else
            {
                // write out the character and the count
                builder.append(first).append(count);
                // update first to this index
                first = str.charAt(i);
                count = 1;
            }
        }
        // add whatever may be at the end
        builder.append(first).append(count);
//        System.out.println("builder.toString() = " + builder.toString());
        if( builder.length() >= str.length() ) return str;
        return builder.toString();
    }

    public void test()
    {
        assertTrue( compress("aabcccccaaa").equals("a2b1c5a3"));
        assertTrue( compress("aabccccca").equals("a2b1c5a1"));
        assertTrue( compress("abcde").equals("abcde"));
        assertTrue( compress("bb").equals("bb"));
        assertTrue( compress("bba").equals("bba"));
        assertTrue( compress("baba").equals("baba"));
        assertTrue( compress("bbb").equals("b3"));
    }

}
