package com.dianafisher.chapter1;

import junit.framework.TestCase;

/**
 * Question 1.0 - implement a method to determine if a string has all unique characters.
 *
 * Assumptions:
 *  ASCII extended characters only (rather than Unicode)
 *
 * */

public class UniqueChars extends TestCase
{
    // Linear run time method - array of boolean values
    public boolean unique(String text)
    {
        // create an array of boolean values
        boolean[] extended_ascii = new boolean[256];
        for( int i = 0; i < text.length(); i++ )
        {
            int character = text.charAt(i);
            // if the boolean value at the index has already been set to true, this character is a duplicate
            if( extended_ascii[character] ) return false;
            else extended_ascii[character] = true;
        }
        return true;
    }

    // Brute force method.  Quadratic, so will need to do better.
    private boolean bruteForceUnique(String text)
    {
        int len = text.length();
        // assuming ASCII (extended ASCII has 256 characters)
        if( len > 256 )
            return false;

        for( int i = 0; i < len; i++ )
            for( int j = i+1; j < len; j++ )
                if( text.charAt(i) == text.charAt(j) )
                    return false;

        return true;
    }

    public void test()
    {
        assertTrue( bruteForceUnique("abcdef") );
        assertFalse( bruteForceUnique("aabcdef") );
        assertFalse( bruteForceUnique("abcdeff") );
        assertTrue( bruteForceUnique("abcdefghijklmnopqrstuvwxyz1234567890") );
        assertFalse( bruteForceUnique("abcdefghijklmnopqrstuvwxyz1234567890a") );
        assertTrue( unique("abcdef") );
        assertFalse( unique("aabcdef") );
        assertFalse( unique("abcdeff") );
        assertTrue( unique("abcdefghijklmnopqrstuvwxyz1234567890") );
        assertFalse( unique("abcdefghijklmnopqrstuvwxyz1234567890a") );
    }
}
