package com.dianafisher.chapter1;

/**
 * Question 1.7 - Write an algorithm such that if an element in an M x N matrix is 0, it's entire row and column are set to 0.
 *
 * Assumptions:
 * */
public class ZeroOut
{
    public static void main(String[] args)
    {
        int N = 10;
        int M = 15;
        int[][] test = new int[N][M];
        // initialize the matrix with some values
        for( int i = 0; i < N; i++ )
            for( int j = 0; j < M; j++ )
                test[i][j] = (int)(Math.random() * 100);

        // print the original matrix
        printMatrix(test);

        new ZeroOut().zeroOut(test);
    }

    /**
     * For every 0 entry in the matrix, sets all values in the the corresponding row and column to zero as well.
     * */
    public void zeroOut( int[][] matrix )
    {
        // Loop through the matrix to see where the zeroes are.
        int count = 0;
        boolean[] rows = new boolean[matrix.length];
        boolean[] cols = new boolean[matrix[0].length];

        System.out.println("rows.length = " + rows.length);
        for( int row = 0; row < matrix.length; row++ )
        {
            for( int col = row; col < matrix[row].length; col++ )
            {
                int value = matrix[row][col];
//                System.out.println(String.format("row = %d, col = %d, value = %d", row, col, value ));
                if( value == 0 )
                {
                    System.out.println(String.format("Found zero at (%d,%d)", row, col ));
                    count++;
                    // mark which row had a zero
                    rows[row] = true;
                    cols[col] = true;
                }
            }
        }
        System.out.println("count = " + count);

        // loop through the columns and zero out any which had a zero in them
        for( int i = 0; i < rows.length; i++ )
        {
            if(rows[i])
            {
                // zero out the row
                for( int index = 0; index < matrix[0].length; index++ )
                {
                    matrix[i][index] = 0;
                }
            }
        }

        for( int i = 0; i < cols.length; i++ )
        {
            if( cols[i])
            {
                // zero out the column
                for( int index = 0; index < matrix.length; index++ )
                    matrix[index][i] = 0;
            }
        }

        printMatrix(matrix);

    }

    public static void printMatrix( int[][] matrix )
    {
        for( int row = 0; row < matrix.length; row++ ){
            System.out.print("[ ");
            for( int column = 0; column < matrix[0].length; column++ ){
                System.out.print(String.format( "%2d ", matrix[row][column] ));
//                System.out.print(String.format( "(%d,%d) %2d ", row, column, matrix[row][column] ));
            }
            System.out.println("]");
        }
    }
}
